<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
        PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
        "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.yiqi.app.mapper.AppCouponTypeApplyClothMapper">

    <resultMap type="AppCouponTypeApplyCloth" id="AppCouponTypeApplyClothResult">
        <result property="id" column="id"/>
        <result property="clothItemId" column="cloth_item_id"/>
        <result property="couponTypeId" column="coupon_type_id"/>
        <result property="delFlag" column="del_flag"/>
        <result property="createById" column="create_by_id"/>
        <result property="createBy" column="create_by"/>
        <result property="createTime" column="create_time"/>
        <result property="updateById" column="update_by_id"/>
        <result property="updateBy" column="update_by"/>
        <result property="updateTime" column="update_time"/>
        <result property="remark" column="remark"/>
    </resultMap>

    <sql id="selectAppCouponTypeApplyClothVo">
        select id, cloth_item_id, coupon_type_id, del_flag, create_by_id, create_by, create_time, update_by_id, update_by, update_time, remark
        from app_coupon_type_apply_cloth
    </sql>


    <sql id="selectAppCouponTypeApplyClothListVo">
        select ctac.*,c.name as clothItemName,ct.name as clothItemTypeName
        from app_coupon_type_apply_cloth as ctac
        left join cloth_item as c on c.id=ctac.cloth_item_id
        left join cloth_type as ct on ct.id=c.type_id
    </sql>

    <select id="selectAppCouponTypeApplyClothList" resultType="com.yiqi.app.domain.vo.AppCouponTypeApplyClothVO">
        <include refid="selectAppCouponTypeApplyClothListVo"/>
        <where>
            <if test="name != null  and name != ''">
                and c.name like concat('%', #{name}, '%')
            </if>
            <if test="typeId != null ">
                and c.type_id = #{typeId}
            </if>
            <if test="couponTypeId != null ">
                and ctac.coupon_type_id = #{couponTypeId}
            </if>
            and ctac.del_flag='0' and c.del_flag='0'
        </where>
    </select>

    <select id="selectAppCouponTypeApplyClothById" parameterType="Long"
            resultMap="AppCouponTypeApplyClothResult">
        <include refid="selectAppCouponTypeApplyClothVo"/>
        where id = #{id}
        and del_flag='0'
    </select>

    <insert id="insertAppCouponTypeApplyCloth" parameterType="AppCouponTypeApplyCloth" useGeneratedKeys="true"
            keyProperty="id">
        insert into app_coupon_type_apply_cloth
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="clothItemId != null">cloth_item_id,
            </if>
            <if test="couponTypeId != null">coupon_type_id,
            </if>
            <if test="delFlag != null">del_flag,
            </if>
            <if test="createById != null">create_by_id,
            </if>
            <if test="createBy != null">create_by,
            </if>
            <if test="createTime != null">create_time,
            </if>
            <if test="updateById != null">update_by_id,
            </if>
            <if test="updateBy != null">update_by,
            </if>
            <if test="updateTime != null">update_time,
            </if>
            <if test="remark != null">remark,
            </if>
        </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="clothItemId != null">#{clothItemId},
            </if>
            <if test="couponTypeId != null">#{couponTypeId},
            </if>
            <if test="delFlag != null">#{delFlag},
            </if>
            <if test="createById != null">#{createById},
            </if>
            <if test="createBy != null">#{createBy},
            </if>
            <if test="createTime != null">#{createTime},
            </if>
            <if test="updateById != null">#{updateById},
            </if>
            <if test="updateBy != null">#{updateBy},
            </if>
            <if test="updateTime != null">#{updateTime},
            </if>
            <if test="remark != null">#{remark},
            </if>
        </trim>
    </insert>

    <update id="updateAppCouponTypeApplyCloth" parameterType="AppCouponTypeApplyCloth">
        update app_coupon_type_apply_cloth
        <trim prefix="SET" suffixOverrides=",">
            <if test="clothItemId != null">cloth_item_id =
                #{clothItemId},
            </if>
            <if test="couponTypeId != null">coupon_type_id =
                #{couponTypeId},
            </if>
            <if test="delFlag != null">del_flag =
                #{delFlag},
            </if>
            <if test="createById != null">create_by_id =
                #{createById},
            </if>
            <if test="createBy != null">create_by =
                #{createBy},
            </if>
            <if test="createTime != null">create_time =
                #{createTime},
            </if>
            <if test="updateById != null">update_by_id =
                #{updateById},
            </if>
            <if test="updateBy != null">update_by =
                #{updateBy},
            </if>
            <if test="updateTime != null">update_time =
                #{updateTime},
            </if>
            <if test="remark != null">remark =
                #{remark},
            </if>
        </trim>
        where id = #{id}
    </update>

    <delete id="deleteAppCouponTypeApplyClothById" parameterType="Long">
        update app_coupon_type_apply_cloth set del_flag='2' where id = #{id}
    </delete>

    <delete id="deleteAppCouponTypeApplyClothByIds" parameterType="String">
        update app_coupon_type_apply_cloth set del_flag='2' where id in
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>



</mapper>